/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	v1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis/kumori/v1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// KukuCertLister helps list KukuCerts.
type KukuCertLister interface {
	// List lists all KukuCerts in the indexer.
	List(selector labels.Selector) (ret []*v1.KukuCert, err error)
	// KukuCerts returns an object that can list and get KukuCerts.
	KukuCerts(namespace string) KukuCertNamespaceLister
	KukuCertListerExpansion
}

// kukuCertLister implements the KukuCertLister interface.
type kukuCertLister struct {
	indexer cache.Indexer
}

// NewKukuCertLister returns a new KukuCertLister.
func NewKukuCertLister(indexer cache.Indexer) KukuCertLister {
	return &kukuCertLister{indexer: indexer}
}

// List lists all KukuCerts in the indexer.
func (s *kukuCertLister) List(selector labels.Selector) (ret []*v1.KukuCert, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.KukuCert))
	})
	return ret, err
}

// KukuCerts returns an object that can list and get KukuCerts.
func (s *kukuCertLister) KukuCerts(namespace string) KukuCertNamespaceLister {
	return kukuCertNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// KukuCertNamespaceLister helps list and get KukuCerts.
type KukuCertNamespaceLister interface {
	// List lists all KukuCerts in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1.KukuCert, err error)
	// Get retrieves the KukuCert from the indexer for a given namespace and name.
	Get(name string) (*v1.KukuCert, error)
	KukuCertNamespaceListerExpansion
}

// kukuCertNamespaceLister implements the KukuCertNamespaceLister
// interface.
type kukuCertNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all KukuCerts in the indexer for a given namespace.
func (s kukuCertNamespaceLister) List(selector labels.Selector) (ret []*v1.KukuCert, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.KukuCert))
	})
	return ret, err
}

// Get retrieves the KukuCert from the indexer for a given namespace and name.
func (s kukuCertNamespaceLister) Get(name string) (*v1.KukuCert, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1.Resource("kukucert"), name)
	}
	return obj.(*v1.KukuCert), nil
}
